//Swing (or was it blues???) Calculator (perhaps jazz...)
//Carlos Gershenson, 2000
//carlos@jlagunez.iquimica.unam.mx

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class Calculator extends JFrame implements ActionListener{
  JTextField tf;
  JButton b0,b1,b2,b3,b4,b5,b6,b7,b8,b9;
  JButton bpo,beq,bpl,bmi,bti,bdi,bmr,bmp,bc,bce;
  JPanel panel,pan;
  String mem;
  int op=0;
  double num;
  Calculator(){
    pan=new JPanel();
    pan.setLayout(new BorderLayout());
    getContentPane().add(pan);
    tf=new JTextField(12);
    tf.addActionListener(this);
    panel=new JPanel();
    panel.setLayout(new GridLayout(0,5, 5, 3));
    b0=new JButton("0");
    b0.addActionListener(this);
    b1=new JButton("1");
    b1.addActionListener(this);
    b2=new JButton("2");
    b2.addActionListener(this);
    b3=new JButton("3");
    b3.addActionListener(this);
    b4=new JButton("4");
    b4.addActionListener(this);
    b5=new JButton("5");
    b5.addActionListener(this);
    b6=new JButton("6");
    b6.addActionListener(this);
    b7=new JButton("7");
    b7.addActionListener(this);
    b8=new JButton("8");
    b8.addActionListener(this);
    b9=new JButton("9");
    b9.addActionListener(this);
    bpo=new JButton(".");
    bpo.addActionListener(this);
    beq=new JButton("=");
    beq.addActionListener(this);
    bpl=new JButton("+");
    bpl.addActionListener(this);
    bmi=new JButton("-");
    bmi.addActionListener(this);
    bti=new JButton("*");
    bti.addActionListener(this);
    bdi=new JButton("/");
    bdi.addActionListener(this);
    bmr=new JButton("MR");
    bmr.addActionListener(this);
    bmp=new JButton("M+");
    bmp.addActionListener(this);
    bc=new JButton("C");
    bc.addActionListener(this);
    bce=new JButton("CE");
    bce.addActionListener(this);
    panel.add(b7);
    panel.add(b8);
    panel.add(b9);
    panel.add(bdi);
    panel.add(bce);
    panel.add(b4);
    panel.add(b5);
    panel.add(b6);
    panel.add(bti);
    panel.add(bc);
    panel.add(b1);
    panel.add(b2);
    panel.add(b3);
    panel.add(bmi);
    panel.add(bmr);
    panel.add(b0);
    panel.add(bpo);
    panel.add(beq);
    panel.add(bpl);
    panel.add(bmp);
    pan.add(BorderLayout.NORTH,tf);
    pan.add(BorderLayout.CENTER,panel);
  }

  public void actionPerformed(ActionEvent event){
    Object sr=event.getSource();
    if (sr==b0){
      tf.setText(tf.getText()+"0");
    }else
    if (sr==b1){
      tf.setText(tf.getText()+"1");
    }else
    if (sr==b2){
      tf.setText(tf.getText()+"2");
    }else
    if (sr==b3){
      tf.setText(tf.getText()+"3");
    }else
    if (sr==b4){
      tf.setText(tf.getText()+"4");
    }else
    if (sr==b5){
      tf.setText(tf.getText()+"5");
    }else
    if (sr==b6){
      tf.setText(tf.getText()+"6");
    }else
    if (sr==b7){
      tf.setText(tf.getText()+"7");
    }else
    if (sr==b8){
      tf.setText(tf.getText()+"8");
    }else
    if (sr==b9){
      tf.setText(tf.getText()+"9");
    }else
    if (sr==bpo){
      tf.setText(tf.getText()+".");
    }else
    if (sr==bpl){
      num=Float.valueOf(tf.getText()).floatValue();
      op=1;
      tf.setText("");
    }else
    if (sr==bmi){
      num=Float.valueOf(tf.getText()).floatValue();
      op=2;
      tf.setText("");
    }else
    if (sr==bti){
      num=Float.valueOf(tf.getText()).floatValue();
      op=3;
      tf.setText("");
    }else
    if (sr==bdi){
      num=Float.valueOf(tf.getText()).floatValue();
      op=4;
      tf.setText("");
    }else
    if (sr==bce){
      tf.setText("");
      op=0;
      num=0;
    }else
    if (sr==bc){
      tf.setText("");
    }else
    if (sr==bmp){
      mem=new String(tf.getText());
    }else
    if (sr==bmr){
      tf.setText(mem);
    }else    
    if (sr==beq){
      double num2=Float.valueOf(tf.getText()).floatValue();
      switch(op){
        case (1):num+=num2;break;
        case (2):num-=num2;break;
        case (3):num*=num2;break;
        case (4):num/=num2;break;
      }
      tf.setText(String.valueOf(num));
    }
  }

  public static void main(String[] args){
    Calculator frame=new Calculator();
    frame.setTitle("G Calculator 2000");
    WindowListener l=new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        System.exit(0);
      }
    };
    frame.addWindowListener(l);
    frame.pack();
    frame.setVisible(true);
  }
}