// {$R Suma.JFM}
// Carlos Gershenson

import java.awt.*;
import java.applet.Applet;

// Class Suma
public class Suma extends Applet
{
  final int MenuBarHeight = 0;
  
  // Component Declaration
  public TextArea output;
  // End of Component Declaration
  
  // init()
  public void init()
  {
    // Frame Initialization
    setForeground(Color.black);
    setBackground(Color.lightGray);
    setFont(new Font("Dialog",Font.BOLD,12));
    setLayout(null);
    // End of Frame Initialization
    
    // Component Initialization
    output = new TextArea("");
    output.setForeground(Color.black);
    output.setBackground(Color.white);
    output.setFont(new Font("Dialog",Font.BOLD,12));
    // End of Component Initialization
    
    // Add()s
    add(output);
    // End of Add()s
    
    InitialPositionSet();
  } // End of init()
  
  // start()
  public void start() {
    output.setText("");
    boolean stop = false,ok = true;
    int sum = 0,i = 0;
    while( ! stop) {
      i++;
      String s = getParameter("p"+i);
      if (s == null) {
        stop = true;
      } else {
        output.appendText(s+"\n");
        try {
          sum += Integer.valueOf(s).intValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
      }
    }
    if (ok) {
      output.appendText("__________________\n"+sum);      
    }
  } // End of start()
  
  // stop()
  public void stop()
  {
  } // End of stop()
  
  // destroy()
  public void destroy()
  {
  } // End of destroy()
  
  public void paint(Graphics g)
  {
    // paint()
    // End of paint()
  }
  
  public void InitialPositionSet()
  {
    // InitialPositionSet()
    resize(392,273);
    output.reshape(6,11+MenuBarHeight,381,255);
    // End of InitialPositionSet()
  }
  
  public boolean handleEvent(Event evt)
  {
    // handleEvent()
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) Suma_WindowDestroy(evt.target);
    // End of handleEvent()
    
    return super.handleEvent(evt);
  }
  
  // Event Handling Routines
  public void Suma_WindowDestroy(Object target)
  {
    System.exit(0);
  }
  
  // End of Event Handling Routines
  
} // End of Class Suma